window.Gleam.initSearch([{"doc":"glethers","title":"glethers","content":"# ethers_gleam\n\n[![Package Version](https://img.shields.io/hexpm/v/ethers_gleam)](https://hex.pm/packages/ethers_gleam)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/ethers_gleam/)\n\n```sh\ngleam add ethers_gleam@1\n```\n```gleam\nimport ethers_gleam\n\npub fn main() {\n  // TODO: An example of the project in use\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/ethers_gleam&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n\n## Planned Features\n\n- [ ] Wallet and Signer with mnemonic\n- [x] Private key parsing\n- [x] Signing and verifying messages\n- [x] Crypto functions: keccak256, sha256, etc\n- [x] Eip712 signed typed message\n- [ ] Blockchain primitives: \n    - [x] Address\n    - [x] Signature\n    - [ ] Transaction\n    - [ ] Block\n    - [ ] signed and unsigned numbers: \n        - [ ] u32\n        - [ ] u64\n        - [ ] u128\n        - [x] u256\n        - [ ] i32\n        - [ ] i64\n        - [ ] i128\n        - [ ] i256\n- [ ] RPC methods\n- [ ] ABI parser\n- [ ] Contract interaction\n- [ ] Websocket connection\n- [ ] Etherscan API\n- [ ] Javascript compatibility\n    - [ ] BigInt\n\nUse big int for js: https://gitlab.com/Nicd/bigi\n","url":"index.html"},{"doc":"glethers/address","title":"Address","content":"pub opaque type Address\n\n\nSynonyms:\nglethers/address.Address\nglethers/address Address","url":"glethers/address.html#Address"},{"doc":"glethers/address","title":"DecodeError","content":"pub type DecodeError {\n  NotEnoughBytes\n  NonHexDecimal\n  IncorrectLength\n}\n\nNotEnoughBytes\n\n\nNonHexDecimal\n\n\nIncorrectLength\n\n\nSynonyms:\nglethers/address.DecodeError\nglethers/address DecodeError","url":"glethers/address.html#DecodeError"},{"doc":"glethers/address","title":"decoder","content":"pub fn decoder(\n  value: Dynamic,\n) -&gt; Result(Address, List(DecodeError))\n\nSynonyms:\nglethers/address.decoder\nglethers/address decoder","url":"glethers/address.html#decoder"},{"doc":"glethers/address","title":"from_string","content":"pub fn from_string(addr: String) -&gt; Result(Address, DecodeError)\n\nSynonyms:\nglethers/address.from_string\nglethers/address from_string","url":"glethers/address.html#from_string"},{"doc":"glethers/address","title":"to_bit_array","content":"pub fn to_bit_array(address: Address) -&gt; BitArray\n\nSynonyms:\nglethers/address.to_bit_array\nglethers/address to_bit_array","url":"glethers/address.html#to_bit_array"},{"doc":"glethers/address","title":"to_string","content":"pub fn to_string(address: Address) -&gt; String\n\nSynonyms:\nglethers/address.to_string\nglethers/address to_string","url":"glethers/address.html#to_string"},{"doc":"glethers/address","title":"glethers/address","content":"","url":"glethers/address.html"},{"doc":"glethers/block","title":"Block","content":"pub type Block {\n  Latest\n  Number(Int)\n}\n\nLatest\n\n\nNumber(Int)\n\n\nSynonyms:\nglethers/block.Block\nglethers/block Block","url":"glethers/block.html#Block"},{"doc":"glethers/block","title":"to_string","content":"pub fn to_string(block: Block) -&gt; String\n\nSynonyms:\nglethers/block.to_string\nglethers/block to_string","url":"glethers/block.html#to_string"},{"doc":"glethers/block","title":"glethers/block","content":"","url":"glethers/block.html"},{"doc":"glethers/contract","title":"Contract","content":"pub type Contract {\n  Contract(functions: List(Function))\n}\n\nContract(functions: List(Function))\n\n\nSynonyms:\nglethers/contract.Contract\nglethers/contract Contract","url":"glethers/contract.html#Contract"},{"doc":"glethers/contract","title":"Function","content":"pub type Function {\n  Function(args: List(String))\n}\n\nFunction(args: List(String))\n\n\nSynonyms:\nglethers/contract.Function\nglethers/contract Function","url":"glethers/contract.html#Function"},{"doc":"glethers/contract","title":"glethers/contract","content":"","url":"glethers/contract.html"},{"doc":"glethers/hash/message","title":"Hash","content":"pub opaque type Hash\n\n\nSynonyms:\nglethers/hash/message.Hash\nglethers/hash/message Hash","url":"glethers/hash/message.html#Hash"},{"doc":"glethers/hash/message","title":"from_bit_array","content":"pub fn from_bit_array(hash: BitArray) -&gt; Result(Hash, String)\n\nSynonyms:\nglethers/hash/message.from_bit_array\nglethers/hash/message from_bit_array","url":"glethers/hash/message.html#from_bit_array"},{"doc":"glethers/hash/message","title":"hash_message","content":"pub fn hash_message(message: String) -&gt; Hash\n\nSynonyms:\nglethers/hash/message.hash_message\nglethers/hash/message hash_message","url":"glethers/hash/message.html#hash_message"},{"doc":"glethers/hash/message","title":"to_bit_array","content":"pub fn to_bit_array(hash: Hash) -&gt; BitArray\n\nSynonyms:\nglethers/hash/message.to_bit_array\nglethers/hash/message to_bit_array","url":"glethers/hash/message.html#to_bit_array"},{"doc":"glethers/hash/message","title":"glethers/hash/message","content":"","url":"glethers/hash/message.html"},{"doc":"glethers/primitives/bytes","title":"Bytes32","content":"pub opaque type Bytes32\n\n\nSynonyms:\nglethers/primitives/bytes.Bytes32\nglethers/primitives/bytes Bytes32","url":"glethers/primitives/bytes.html#Bytes32"},{"doc":"glethers/primitives/bytes","title":"decoder","content":"pub fn decoder(\n  value: Dynamic,\n) -&gt; Result(Bytes32, List(DecodeError))\n\nSynonyms:\nglethers/primitives/bytes.decoder\nglethers/primitives/bytes decoder","url":"glethers/primitives/bytes.html#decoder"},{"doc":"glethers/primitives/bytes","title":"from_bit_array","content":"pub fn from_bit_array(\n  bytes32: BitArray,\n) -&gt; Result(Bytes32, String)\n\nSynonyms:\nglethers/primitives/bytes.from_bit_array\nglethers/primitives/bytes from_bit_array","url":"glethers/primitives/bytes.html#from_bit_array"},{"doc":"glethers/primitives/bytes","title":"to_bit_array","content":"pub fn to_bit_array(bytes32: Bytes32) -&gt; BitArray\n\nSynonyms:\nglethers/primitives/bytes.to_bit_array\nglethers/primitives/bytes to_bit_array","url":"glethers/primitives/bytes.html#to_bit_array"},{"doc":"glethers/primitives/bytes","title":"glethers/primitives/bytes","content":"","url":"glethers/primitives/bytes.html"},{"doc":"glethers/primitives/integer","title":"Uint256","content":"pub type Uint256 {\n  Uint256(Int)\n}\n\nUint256(Int)\n\n\nSynonyms:\nglethers/primitives/integer.Uint256\nglethers/primitives/integer Uint256","url":"glethers/primitives/integer.html#Uint256"},{"doc":"glethers/primitives/integer","title":"decoder","content":"pub fn decoder(\n  value: Dynamic,\n) -&gt; Result(Uint256, List(DecodeError))\n\nSynonyms:\nglethers/primitives/integer.decoder\nglethers/primitives/integer decoder","url":"glethers/primitives/integer.html#decoder"},{"doc":"glethers/primitives/integer","title":"to_bit_array","content":"pub fn to_bit_array(value: Uint256) -&gt; BitArray\n\nSynonyms:\nglethers/primitives/integer.to_bit_array\nglethers/primitives/integer to_bit_array","url":"glethers/primitives/integer.html#to_bit_array"},{"doc":"glethers/primitives/integer","title":"glethers/primitives/integer","content":"","url":"glethers/primitives/integer.html"},{"doc":"glethers/primitives","title":"Primitive","content":"pub type Primitive {\n  String(String)\n  Uint256(integer.Uint256)\n  Bytes32(bytes.Bytes32)\n  Address(Address)\n}\n\nString(String)\n\n\nUint256(integer.Uint256)\n\n\nBytes32(bytes.Bytes32)\n\n\nAddress(Address)\n\n\nSynonyms:\nglethers/primitives.Primitive\nglethers/primitives Primitive","url":"glethers/primitives.html#Primitive"},{"doc":"glethers/primitives","title":"eip712_encode","content":"pub fn eip712_encode(value: Primitive) -&gt; BitArray\n\nSynonyms:\nglethers/primitives.eip712_encode\nglethers/primitives eip712_encode","url":"glethers/primitives.html#eip712_encode"},{"doc":"glethers/primitives","title":"from","content":"pub fn from(value: a) -&gt; Result(Primitive, List(DecodeError))\n\nSynonyms:\nglethers/primitives.from\nglethers/primitives from","url":"glethers/primitives.html#from"},{"doc":"glethers/primitives","title":"from_address","content":"pub fn from_address(value: Address) -&gt; Primitive\n\nSynonyms:\nglethers/primitives.from_address\nglethers/primitives from_address","url":"glethers/primitives.html#from_address"},{"doc":"glethers/primitives","title":"from_bytes32","content":"pub fn from_bytes32(value: Bytes32) -&gt; Primitive\n\nSynonyms:\nglethers/primitives.from_bytes32\nglethers/primitives from_bytes32","url":"glethers/primitives.html#from_bytes32"},{"doc":"glethers/primitives","title":"from_string","content":"pub fn from_string(value: String) -&gt; Primitive\n\nSynonyms:\nglethers/primitives.from_string\nglethers/primitives from_string","url":"glethers/primitives.html#from_string"},{"doc":"glethers/primitives","title":"from_uint256","content":"pub fn from_uint256(value: Uint256) -&gt; Primitive\n\nSynonyms:\nglethers/primitives.from_uint256\nglethers/primitives from_uint256","url":"glethers/primitives.html#from_uint256"},{"doc":"glethers/primitives","title":"glethers/primitives","content":"","url":"glethers/primitives.html"},{"doc":"glethers/hash/typed_data","title":"ComplexField","content":"pub type ComplexField {\n  Primitive(primitives.Primitive)\n  Struct(TypedData)\n}\n\nPrimitive(primitives.Primitive)\n\n\nStruct(TypedData)\n\n\nSynonyms:\nglethers/hash/typed_data.ComplexField\nglethers/hash/typed_data ComplexField","url":"glethers/hash/typed_data.html#ComplexField"},{"doc":"glethers/hash/typed_data","title":"TypedData","content":"pub type TypedData =\n  #(String, TypedDataValues)\n\n\nSynonyms:\nglethers/hash/typed_data.TypedData\nglethers/hash/typed_data TypedData","url":"glethers/hash/typed_data.html#TypedData"},{"doc":"glethers/hash/typed_data","title":"TypedDataDomain","content":"pub type TypedDataDomain {\n  TypedDataDomain(\n    name: Option(String),\n    version: Option(String),\n    chain_id: Option(integer.Uint256),\n    verifying_contract: Option(Address),\n    salt: Option(bytes.Bytes32),\n  )\n}\n\nTypedDataDomain(\n  name: Option(String),\n  version: Option(String),\n  chain_id: Option(integer.Uint256),\n  verifying_contract: Option(Address),\n  salt: Option(bytes.Bytes32),\n)\n\n\nSynonyms:\nglethers/hash/typed_data.TypedDataDomain\nglethers/hash/typed_data TypedDataDomain","url":"glethers/hash/typed_data.html#TypedDataDomain"},{"doc":"glethers/hash/typed_data","title":"TypedDataValues","content":"pub type TypedDataValues =\n  List(#(String, ComplexField))\n\n\nSynonyms:\nglethers/hash/typed_data.TypedDataValues\nglethers/hash/typed_data TypedDataValues","url":"glethers/hash/typed_data.html#TypedDataValues"},{"doc":"glethers/hash/typed_data","title":"encode_data","content":"pub fn encode_data(\n  values: #(String, List(#(String, ComplexField))),\n) -&gt; BitArray\n\nSynonyms:\nglethers/hash/typed_data.encode_data\nglethers/hash/typed_data encode_data","url":"glethers/hash/typed_data.html#encode_data"},{"doc":"glethers/hash/typed_data","title":"encode_type","content":"pub fn encode_type(\n  typed_data: #(String, List(#(String, ComplexField))),\n) -&gt; String\n\nSynonyms:\nglethers/hash/typed_data.encode_type\nglethers/hash/typed_data encode_type","url":"glethers/hash/typed_data.html#encode_type"},{"doc":"glethers/hash/typed_data","title":"hash_domain","content":"pub fn hash_domain(domain: TypedDataDomain) -&gt; BitArray\n\nSynonyms:\nglethers/hash/typed_data.hash_domain\nglethers/hash/typed_data hash_domain","url":"glethers/hash/typed_data.html#hash_domain"},{"doc":"glethers/hash/typed_data","title":"hash_message","content":"pub fn hash_message(\n  domain: TypedDataDomain,\n  struct: a,\n  encoder: fn(a) -&gt; #(String, List(#(String, ComplexField))),\n) -&gt; Hash\n\nSynonyms:\nglethers/hash/typed_data.hash_message\nglethers/hash/typed_data hash_message","url":"glethers/hash/typed_data.html#hash_message"},{"doc":"glethers/hash/typed_data","title":"hash_struct","content":"pub fn hash_struct(\n  data: #(String, List(#(String, ComplexField))),\n) -&gt; BitArray\n\nSynonyms:\nglethers/hash/typed_data.hash_struct\nglethers/hash/typed_data hash_struct","url":"glethers/hash/typed_data.html#hash_struct"},{"doc":"glethers/hash/typed_data","title":"glethers/hash/typed_data","content":"","url":"glethers/hash/typed_data.html"},{"doc":"glethers/rpc/calls","title":"JsonRpcError","content":"pub type JsonRpcError {\n  JsonRpcError(code: Int, message: String)\n}\n\nJsonRpcError(code: Int, message: String)\n\n\nSynonyms:\nglethers/rpc/calls.JsonRpcError\nglethers/rpc/calls JsonRpcError","url":"glethers/rpc/calls.html#JsonRpcError"},{"doc":"glethers/rpc/calls","title":"JsonRpcResponse","content":"pub type JsonRpcResponse {\n  Result(id: Int, jsonrpc: String, result: dynamic.Dynamic)\n  Error(id: Int, jsonrpc: String, error: JsonRpcError)\n}\n\nResult(id: Int, jsonrpc: String, result: dynamic.Dynamic)\n\n\nError(id: Int, jsonrpc: String, error: JsonRpcError)\n\n\nSynonyms:\nglethers/rpc/calls.JsonRpcResponse\nglethers/rpc/calls JsonRpcResponse","url":"glethers/rpc/calls.html#JsonRpcResponse"},{"doc":"glethers/rpc/calls","title":"RpcRequest","content":"pub type RpcRequest {\n  RpcRequest(\n    method: String,\n    params: List(String),\n    id: Int,\n    jsonrpc: String,\n  )\n}\n\nRpcRequest(\n  method: String,\n  params: List(String),\n  id: Int,\n  jsonrpc: String,\n)\n\n\nSynonyms:\nglethers/rpc/calls.RpcRequest\nglethers/rpc/calls RpcRequest","url":"glethers/rpc/calls.html#RpcRequest"},{"doc":"glethers/rpc/calls","title":"decode","content":"pub fn decode(\n  json_string: String,\n) -&gt; Result(JsonRpcResponse, DecodeError)\n\nSynonyms:\nglethers/rpc/calls.decode\nglethers/rpc/calls decode","url":"glethers/rpc/calls.html#decode"},{"doc":"glethers/rpc/calls","title":"encode_rpc_call","content":"pub fn encode_rpc_call(json_rpc_call: RpcRequest) -&gt; Json\n\nSynonyms:\nglethers/rpc/calls.encode_rpc_call\nglethers/rpc/calls encode_rpc_call","url":"glethers/rpc/calls.html#encode_rpc_call"},{"doc":"glethers/rpc/calls","title":"glethers/rpc/calls","content":"","url":"glethers/rpc/calls.html"},{"doc":"glethers/rpc/methods","title":"RpcMethod","content":"pub type RpcMethod {\n  BlockNumber\n  ChainId\n  GasPrice\n  GetAccount(address: address.Address, block: block.Block)\n  GetBalance(address: address.Address, block: block.Block)\n}\n\nBlockNumber\n\n\nChainId\n\n\nGasPrice\n\n\nGetAccount(address: address.Address, block: block.Block)\n\n\nGetBalance(address: address.Address, block: block.Block)\n\n\nSynonyms:\nglethers/rpc/methods.RpcMethod\nglethers/rpc/methods RpcMethod","url":"glethers/rpc/methods.html#RpcMethod"},{"doc":"glethers/rpc/methods","title":"convert_to_body","content":"pub fn convert_to_body(method: RpcMethod) -&gt; String\n\nSynonyms:\nglethers/rpc/methods.convert_to_body\nglethers/rpc/methods convert_to_body","url":"glethers/rpc/methods.html#convert_to_body"},{"doc":"glethers/rpc/methods","title":"glethers/rpc/methods","content":"","url":"glethers/rpc/methods.html"},{"doc":"glethers/provider","title":"Provider","content":"pub type Provider {\n  Rpc(endpoint: String)\n}\n\nRpc(endpoint: String)\n\n\nSynonyms:\nglethers/provider.Provider\nglethers/provider Provider","url":"glethers/provider.html#Provider"},{"doc":"glethers/provider","title":"ProviderError","content":"pub type ProviderError {\n  DecodeError(json.DecodeError)\n}\n\nDecodeError(json.DecodeError)\n\n\nSynonyms:\nglethers/provider.ProviderError\nglethers/provider ProviderError","url":"glethers/provider.html#ProviderError"},{"doc":"glethers/provider","title":"decode_response","content":"pub fn decode_response(\n  body: Response(String),\n) -&gt; Result(JsonRpcResponse, DecodeError)\n\nSynonyms:\nglethers/provider.decode_response\nglethers/provider decode_response","url":"glethers/provider.html#decode_response"},{"doc":"glethers/provider","title":"to_request","content":"pub fn to_request(\n  provider: Provider,\n  method: RpcMethod,\n) -&gt; Request(String)\n\nSynonyms:\nglethers/provider.to_request\nglethers/provider to_request","url":"glethers/provider.html#to_request"},{"doc":"glethers/provider","title":"glethers/provider","content":"","url":"glethers/provider.html"},{"doc":"glethers/signer/signing_key","title":"PrivateKey","content":"pub opaque type PrivateKey\n\n\nSynonyms:\nglethers/signer/signing_key.PrivateKey\nglethers/signer/signing_key PrivateKey","url":"glethers/signer/signing_key.html#PrivateKey"},{"doc":"glethers/signer/signing_key","title":"PrivateKeyError","content":"pub type PrivateKeyError {\n  WrongLength\n  FailedBase16Decode\n}\n\nWrongLength\n\n\nFailedBase16Decode\n\n\nSynonyms:\nglethers/signer/signing_key.PrivateKeyError\nglethers/signer/signing_key PrivateKeyError","url":"glethers/signer/signing_key.html#PrivateKeyError"},{"doc":"glethers/signer/signing_key","title":"from_string","content":"pub fn from_string(\n  private_key: String,\n) -&gt; Result(PrivateKey, PrivateKeyError)\n\nSynonyms:\nglethers/signer/signing_key.from_string\nglethers/signer/signing_key from_string","url":"glethers/signer/signing_key.html#from_string"},{"doc":"glethers/signer/signing_key","title":"to_bit_array","content":"pub fn to_bit_array(private_key: PrivateKey) -&gt; BitArray\n\nSynonyms:\nglethers/signer/signing_key.to_bit_array\nglethers/signer/signing_key to_bit_array","url":"glethers/signer/signing_key.html#to_bit_array"},{"doc":"glethers/signer/signing_key","title":"glethers/signer/signing_key","content":"","url":"glethers/signer/signing_key.html"},{"doc":"glethers/signer","title":"Signature","content":"pub type Signature =\n  secp256k1_gleam.Signature\n\n\nSynonyms:\nglethers/signer.Signature\nglethers/signer Signature","url":"glethers/signer.html#Signature"},{"doc":"glethers/signer","title":"Signer","content":"pub type Signer {\n  Signer(provider: provider.Provider, private_key: PrivateKey)\n}\n\nSigner(provider: provider.Provider, private_key: PrivateKey)\n\n\nSynonyms:\nglethers/signer.Signer\nglethers/signer Signer","url":"glethers/signer.html#Signer"},{"doc":"glethers/signer","title":"sign_hash","content":"pub fn sign_hash(\n  private_key: PrivateKey,\n  hash: Hash,\n) -&gt; Signature\n\nSynonyms:\nglethers/signer.sign_hash\nglethers/signer sign_hash","url":"glethers/signer.html#sign_hash"},{"doc":"glethers/signer","title":"sign_message","content":"pub fn sign_message(\n  private_key: PrivateKey,\n  message: String,\n) -&gt; Signature\n\nSynonyms:\nglethers/signer.sign_message\nglethers/signer sign_message","url":"glethers/signer.html#sign_message"},{"doc":"glethers/signer","title":"sign_typed_data","content":"pub fn sign_typed_data(\n  private_key: PrivateKey,\n  domain: TypedDataDomain,\n  struct: a,\n  encoder: fn(a) -&gt; #(String, List(#(String, ComplexField))),\n) -&gt; Signature\n\nSynonyms:\nglethers/signer.sign_typed_data\nglethers/signer sign_typed_data","url":"glethers/signer.html#sign_typed_data"},{"doc":"glethers/signer","title":"verify_signature","content":"pub fn verify_signature(\n  private_key: PrivateKey,\n  message: String,\n  signature: Signature,\n) -&gt; Bool\n\nSynonyms:\nglethers/signer.verify_signature\nglethers/signer verify_signature","url":"glethers/signer.html#verify_signature"},{"doc":"glethers/signer","title":"glethers/signer","content":"","url":"glethers/signer.html"}]);